#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_processref_mp_xi4.py">
#<verify4xi verification = "10" target = "manager4xi.py"/>
#<contextualize4xi context = "process4xi.py; queue4xi.py; pipe4xi.py; lock4xi.py; pool4xi.py"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'test_test_processref_mp_xi4',
            'print_trace4xi',
            'set_trace4xi',
            'phase2',
            'phase1',
            'expxi8',
            'expxi4',
            'expxi2',
            'ace',
            'reason',
            'sense']            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   


#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
from multiprocessing.process import Process
from multiprocessing.queues  import Queue
from multiprocessing.connection import Pipe
from multiprocessing.synchronize import Lock
from multiprocessing import Manager #<--- this is because Manager function is defined in __init__.py module!
from multiprocessing.pool import Pool
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from process4xi import Process4Xi
from queue4xi  import Queue4Xi
from pipe4xi import Pipe4Xi
from lock4xi import Lock4Xi
from manager4xi import Manager4Xi
from pool4xi import Pool4Xi

from print4xi import Print4Xi
from print4xi import print4xi
from time4xi import time4xi

from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
        'Process4Xi': 'NACK4TRACE',
        'Queue4Xi': 'NACK4TRACE',
        'Pipe4Xi': 'NACK4TRACE',
        'Lock4Xi': 'NACK4TRACE',
        'Manager4Xi': 'NACK4TRACE',
        'Pool4Xi': 'NACK4TRACE',
        'worker4xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>       

# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   printing trace
#">                    
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-processref4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Process References in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Process References in Multiprocessing.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-processref4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Process References in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Process References in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-processref4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Process References in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Process References in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "sense" usage = "
#   test
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def sense(target_param, queue_param, pipe_param,lock_param,dict_param,list_param):
    target_xi2 = target_param
    queue_xi2 = queue_param
    pipe_publisher_channel_xi2 = pipe_param
    lock_xi2 = lock_param
    dict_xi2 = dict_param
    list_xi2 = list_param
    
    
    print("SENSE: ", target_xi2)
    # ---------------------------------------------------------------------------------------------
    # put a message to the queue
    # 
    queue_xi2.put(['DragonXi2_00', target_xi2, 'sensing!']) # puts to its queue
    # ---------------------------------------------------------------------------------------------
    # reserve the pipe using the lock, send messages and release the pipe
    # 
    lock_xi2.acquire()

    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_01', 'BIO ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_02', 'CO2 ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_03', 'Coal ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_04', 'Diesel ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_05', 'Electricity ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_06', 'Fusion ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_07', 'Gas ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_08', 'Geo ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_09', 'Hydrogen ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_10', 'Lithium ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_11', 'Nuclear Power ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_12', 'Ocean ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_13', 'Oil ',target_xi2]) 
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_14', 'Solar ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_15', 'Wind ',target_xi2])
    
    dict_xi2[1] = "BIO"
    dict_xi2[2] = "CO2"
    dict_xi2[3] = "Coal"
    dict_xi2[4] = "Diesel"
    dict_xi2[5] = "Electricity"
    dict_xi2[6] = "Fusion"
    dict_xi2[7] = "Gas"
    dict_xi2[8] = "Geo"
    dict_xi2[9] = "Hydrogen"
    dict_xi2[10] = "Lithium"
    dict_xi2[11] = "Nuclear Power"
    dict_xi2[12] = "Ocean"
    dict_xi2[13] = "Oil"
    dict_xi2[14] = "Solar"
    dict_xi2[15] = "Wind"
    

    lock_xi2.release() 
    
#</function4xi>
           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "reason" usage = "
#   testing
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ------------------------------------------------------------------------------------------------- 
def reason(target_param, queue_param, pipe_param,lock_param,dict_param,list_param):
    target_xi4 = target_param
    queue_xi4 = queue_param
    pipe_publisher_channel_xi4 = pipe_param
    lock_xi4 = lock_param
    dict_xi4 = dict_param
    list_xi8 = list_param
    
    print("REASON: ", target_xi4)
    # ---------------------------------------------------------------------------------------------
    # put a message to the queue
    # 
    queue_xi4.put(['DragonXi4_00', target_xi4, 'portfolio must be sustainable!']) # puts to its queue 
    # ---------------------------------------------------------------------------------------------
    # reserve the pipe using the lock, send messages and release the pipe
    # 
    lock_xi4.acquire()
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_01', 'BIO ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_02', 'Geo ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_03', 'Hydrogen ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_04', 'Nuclear Power ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_05', 'Ocean ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_06', 'Solar ',target_xi4])
    pipe_publisher_channel_xi4.send(['DragonXi4_Reasoning_07', 'Wind ',target_xi4])    

    dict_xi4[1] = "BIO"
    dict_xi4[2] = "Geo"
    dict_xi4[3] = "Hydrogen"
    dict_xi4[4] = "Nuclear Power"
    dict_xi4[5] = "Ocean"
    dict_xi4[6] = "Solar"
    dict_xi4[7] = "Wind"
    
    lock_xi4.release()
    
#</function4xi>
     
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "ace" usage = "
#   testing
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def ace(target_param, queue_param, pipe_param,lock_param,dict_param,list_param):
    # ---------------------------------------------------------------------------------------------
    # 
    # 
    target_xi8 = target_param
    queue_xi8 = queue_param
    pipe_publisher_channel_xi8 = pipe_param
    lock_xi8 = lock_param
    dict_xi8 = dict_param
    list_xi8 = list_param
    
    print("ACE: ", target_xi8)
    # ---------------------------------------------------------------------------------------------
    # put a message to the queue
    # 
    queue_xi8.put(['DragonXi8_00', target_xi8, 'to be aced!']) # puts to its queue       
    
    # ---------------------------------------------------------------------------------------------
    # reserve the pipe using the lock, send messages and release the pipe
    # 
    lock_xi8.acquire()
    pipe_publisher_channel_xi8.send(['DragonXi8_Ace_01', 'BIO ',target_xi8])
    pipe_publisher_channel_xi8.send(['DragonXi8_Ace_02', 'Hydrogen ',target_xi8])
    pipe_publisher_channel_xi8.send(['DragonXi8_Ace_03', 'Nuclear Power ',target_xi8])
    pipe_publisher_channel_xi8.send(['DragonXi8_Ace_04', 'Solar ',target_xi8])
    pipe_publisher_channel_xi8.send(['DragonXi8_Ace_05', 'Wind ',target_xi8])    

    dict_xi8[1] = "BIO"
    dict_xi8[2] = "Hydrogen"
    dict_xi8[3] = "Nuclear Power"
    dict_xi8[4] = "Solar"
    dict_xi8[5] = "Wind"
    
    lock_xi8.release()
    
#</function4xi>
     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "expxi2" usage = "
#   two exponent
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def expxi2(x_param):
    xi2 = x_param
    return xi2*xi2
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
# expxi4 function for pool workers
#<function4xi function = "expxi4" usage = "
#   four exponent
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def expxi4(x_param):
    xi4 = x_param
    return xi4*xi4*xi4*xi4
#</function4xi>
     
# -------------------------------------------------------------------------------------------------
# expxi8 function for pool workers
#<function4xi function = "expxi8" usage = "
#   eight exponent
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def expxi8(x_param):
    xi8 = x_param
    return xi8*xi8*xi8*xi8*xi8*xi8*xi8*xi8         
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "phase1" usage = "
#   process reference testing with multiprocessing
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def phase1():    
    # ---------------------------------------------------------------------------------------------
    # create multiprocessing queues for sensing, reasoning and acing
    # 
    queue2xi = Queue()
    queue4xi = Queue()
    queue8xi = Queue()
    # ---------------------------------------------------------------------------------------------
    # create multiprocessing pipes with consumer and publisher ends
    #     
    pipe2xi_consumer_channel, pipe2xi_publisher_channel = Pipe()
    pipe4xi_consumer_channel, pipe4xi_publisher_channel = Pipe()
    pipe8xi_consumer_channel, pipe8xi_publisher_channel = Pipe()
    # ---------------------------------------------------------------------------------------------
    # create three locks
    #   
    lock_xi2 = Lock()
    lock_xi4 = Lock()
    lock_xi8 = Lock()    
    # ---------------------------------------------------------------------------------------------
    # create three managers
    #       
    manager2xi = Manager()
    manager4xi = Manager()
    manager8xi = Manager()
    # ---------------------------------------------------------------------------------------------
    # create three dictionaries using each manager
    #      
    dict2xi = manager2xi.dict()
    dict4xi = manager4xi.dict()
    dict8xi = manager8xi.dict()
    
    # ---------------------------------------------------------------------------------------------
    # create three lists using each manager
    #      
    list2xi = manager2xi.list(range(15))
    list4xi = manager4xi.list(range(7))
    list8xi = manager8xi.list(range(5))
    
        
    # ---------------------------------------------------------------------------------------------
    # SENSE IT!
    #        create a process and use its services such the content it sends via its queue and pipe    
    #
    print("\n~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~")
    process2xi = Process(target=sense, args=('Energy ',queue2xi, pipe2xi_publisher_channel,lock_xi2,dict2xi,list2xi))
    process2xi.start()
    
    print ("process2xi alive status: ", process2xi.is_alive())       # check whether the process is alive
    print ("process2xi name: ", process2xi.name)                     # the name of the process
    print ("process2xi PID: ", process2xi.ident)                     # pid = ident of the process
    print ("process2xi authentication key: ", process2xi.authkey)    # authorization key given by the system
    
    print (queue2xi.get())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    
    print("\n Dictionary created by manager2xi and updated by process2xi:")
    print (dict2xi)
    
    print("\n List for manager2xi and process2xi:")
    print (list2xi)
    
    process2xi.join()
    print ("process2xi exit code after join : ", process2xi.exitcode) # see how the process did exit
    
    # ---------------------------------------------------------------------------------------------
    # REASON IT!
    #        create a process and use its services such the content it sends via its queue and pipe    
    # 
    print("\n~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~")
    process4xi = Process(target=reason, args=('Energy ',queue4xi, pipe4xi_publisher_channel,lock_xi4,dict4xi,list8xi))
    process4xi.start()
    
       
    print ("process4xi alive status: ", process4xi.is_alive())       # check whether the process is alive
    print ("process4xi name: ", process4xi.name)                     # the name of the process
    print ("process4xi PID: ", process4xi.ident)                     # pid = ident of the process
    print ("process4xi authentication key: ", process4xi.authkey)    # authorization key given by the system
    
    
    print (queue4xi.get())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    
    print("\n Dictionary created by manager4xi and updated by process4xi:")
    print (dict4xi)
    
    print("\n List for manager4xi and process4xi:")
    print (list4xi)
    
    process4xi.join()
    print ("process4xi exit code after join : ", process4xi.exitcode) # see how the process did exit
    
    # ---------------------------------------------------------------------------------------------
    # ACE IT!
    #        create a process and use its services such the content it sends via its queue and pipe    
    # 
    print("\n~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~")
    process8xi = Process(target=ace, args=('Energy ',queue8xi, pipe8xi_publisher_channel,lock_xi8,dict8xi,list8xi))
    process8xi.start()
    
           
    print ("process8xi alive status: ", process8xi.is_alive())       # check whether the process is alive
    print ("process8xi name: ", process8xi.name)                     # the name of the process
    print ("process8xi PID: ", process8xi.ident)                     # pid = ident of the process
    print ("process8xi authentication key: ", process8xi.authkey)    # authorization key given by the system
    
    
    print (queue8xi.get())
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    
    print("\n Dictionary created by manager8xi and updated by process8xi:")
    print (dict8xi)
    
    print("\n List for manager8xi and process8xi:")
    print (list8xi)
    
    process8xi.join()
    print ("process8xi exit code after join : ", process8xi.exitcode) # see how the process did exit
    
    # ---------------------------------------------------------------------------------------------
    # create three pools with worker processes 
    #        
    pool2xi = Pool(processes=2)
    pool4xi = Pool(processes=4)
    pool8xi = Pool(processes=8)

    result2xi = pool2xi.apply_async(expxi2, (20,))
    print ("\nResult from pool2xi workers: ",result2xi.get(timeout=1))    
    
    result4xi = pool4xi.apply_async(expxi4, (40,))
    print ("\nResult from pool4xi workers: ",result4xi.get(timeout=1))
    
    result8xi = pool8xi.apply_async(expxi8, (80,))
    print ("\nResult from pool8xi workers: ",result8xi.get(timeout=1))
    
        
    print("\n===============================================================") 
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
#<function4xi function = "phase2" usage = "
#   process reference test with dragonized multiprocessing
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def phase2():    
    # ---------------------------------------------------------------------------------------------
    # create multiprocessing queues for sensing, reasoning and acing
    # 
    queue2xi = Queue4Xi()
    queue4xi = Queue4Xi()
    queue8xi = Queue4Xi()
    # ---------------------------------------------------------------------------------------------
    # create multiprocessing pipes with consumer and publisher ends
    #     
    pipe2xi_consumer_channel, pipe2xi_publisher_channel = Pipe4Xi()
    pipe4xi_consumer_channel, pipe4xi_publisher_channel = Pipe4Xi()
    pipe8xi_consumer_channel, pipe8xi_publisher_channel = Pipe4Xi()
    # ---------------------------------------------------------------------------------------------
    # create three locks
    #   
    lock_xi2 = Lock4Xi()
    lock_xi4 = Lock4Xi()
    lock_xi8 = Lock4Xi()    
    # ---------------------------------------------------------------------------------------------
    # create three managers
    #       
    manager2xi = Manager4Xi()
    manager4xi = Manager4Xi()
    manager8xi = Manager4Xi()
    # ---------------------------------------------------------------------------------------------
    # create three dictionaries using each manager
    #      
    dict2xi = manager2xi.dict()
    dict4xi = manager4xi.dict()
    dict8xi = manager8xi.dict()
    
    # ---------------------------------------------------------------------------------------------
    # create three lists using each manager
    #      
    list2xi = manager2xi.list(range(15))
    list4xi = manager4xi.list(range(7))
    list8xi = manager8xi.list(range(5))
    
        
    # ---------------------------------------------------------------------------------------------
    # SENSE IT!
    #        create a process and use its services such the content it sends via its queue and pipe    
    #
    print("\n(STEP 1/33) SENSE IT with yourDragonXi OF TEST_PROCESSREF_MP_XI4 ", time4xi()) 
    # 01/15/13 Pacific Standard Time
    
    process2xi = Process4Xi(target=sense, args=('Energy ',queue2xi, pipe2xi_publisher_channel,lock_xi2,dict2xi,list2xi))
    
    process2xi.start()
    
    process2xi.run()
    
    print ("(STEP 2A/33) process2xi alive status OF TEST_PROCESSREF_MP_XI4: ", process2xi.is_alive())       # check whether the process is alive
    # True
    print ("(STEP 2B/33) process2xi name OF TEST_PROCESSREF_MP_XI4: ", process2xi.name)                     # the name of the process
    # Process4Xi-1
    print ("(STEP 2C/33) process2xi PID OF TEST_PROCESSREF_MP_XI4: ", process2xi.ident)                     # pid = ident of the process
    # 4032
    print ("(STEP 2D/33) process2xi authentication key OF TEST_PROCESSREF_MP_XI4: ", process2xi.authkey)    # authorization key given by the system
    # b"@`\x96\x849\x18\x831g\x81p\xb2\x06\x9a\xdc;\xa1\x85<\xba\x0b\xcc'u\xef\x83\xe84F&!\xb7"
    
    print (queue2xi.get())
    # ['DragonXi2_00', 'Energy ', 'sensing!']
    
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    print (pipe2xi_consumer_channel.recv())
    # ['DragonXi2_Sensing_01', 'BIO ', 'Energy ']
    # ['DragonXi2_Sensing_02', 'CO2 ', 'Energy ']
    # ['DragonXi2_Sensing_03', 'Coal ', 'Energy ']
    # ['DragonXi2_Sensing_04', 'Diesel ', 'Energy ']
    # ['DragonXi2_Sensing_05', 'Electricity ', 'Energy ']
    # ['DragonXi2_Sensing_06', 'Fusion ', 'Energy ']
    # ['DragonXi2_Sensing_07', 'Gas ', 'Energy ']
    # ['DragonXi2_Sensing_08', 'Geo ', 'Energy ']
    # ['DragonXi2_Sensing_09', 'Hydrogen ', 'Energy ']
    # ['DragonXi2_Sensing_10', 'Lithium ', 'Energy ']
    # ['DragonXi2_Sensing_11', 'Nuclear Power ', 'Energy ']
    # ['DragonXi2_Sensing_12', 'Ocean ', 'Energy ']
    # ['DragonXi2_Sensing_13', 'Oil ', 'Energy ']
    # ['DragonXi2_Sensing_14', 'Solar ', 'Energy ']
    # ['DragonXi2_Sensing_15', 'Wind ', 'Energy ']
         
    
    print("\n(STEP 3A/33) Dictionary created by manager2xi and updated by process2xi OF TEST_PROCESSREF_MP_XI4 ", time4xi())
    print (dict2xi)
    # {1: 'BIO', 2: 'CO2', 3: 'Coal', 4: 'Diesel', 5: 'Electricity', 6: 'Fusion', 7: 'Gas', 8: 'Geo', 9: 'Hydrogen', 10: 'Lithium', 11: 'Nuclear Power', 12: 'Ocean', 13: 'Oil', 14: 'Solar', 15: 'Wind'}
    
    print("\n(STEP 3B/33) List for manager2xi and process2xi OF TEST_PROCESSREF_MP_XI4 ", time4xi())
    print (list2xi)
    # [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14]
    
    process2xi.join()
    print ("(STEP 3C/33) process2xi exit code after join OF TEST_PROCESSREF_MP_XI4: ", process2xi.exitcode) # see how the process did exit
    # 0
    
    # ---------------------------------------------------------------------------------------------
    # REASON IT!
    #        create a process and use its services such the content it sends via its queue and pipe    
    # 
    print("\n(STEP 4A/33) REASON IT with yourDragonXi! OF TEST_PROCESSREF_MP_XI4 ", time4xi())
    # 06:31:21 01/15/13 Pacific Standard Time
    
    process4xi = Process4Xi(target=reason, args=('Energy ',queue4xi, pipe4xi_publisher_channel,lock_xi4,dict4xi,list8xi))
    
    process4xi.start()
    
    process4xi.run()
       
    print ("(STEP 4B/33)process4xi alive status OF TEST_PROCESSREF_MP_XI4: ", process4xi.is_alive())       # check whether the process is alive
    # True
    
    print ("(STEP 4C/33)process4xi name OF TEST_PROCESSREF_MP_XI4: ", process4xi.name)                     # the name of the process
    # Process4Xi-2
    
    print ("(STEP 4D/33)process4xi PID OF TEST_PROCESSREF_MP_XI4: ", process4xi.ident)                     # pid = ident of the process
    # 4248
    
    print ("(STEP 4E/33)process4xi authentication key OF TEST_PROCESSREF_MP_XI4: ", process4xi.authkey)    # authorization key given by the system
    # b"@`\x96\x849\x18\x831g\x81p\xb2\x06\x9a\xdc;\xa1\x85<\xba\x0b\xcc'u\xef\x83\xe84F&!\xb7"
    
    print (queue4xi.get())
    # ['DragonXi4_00', 'Energy ', 'portfolio must be sustainable!']
      
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    print (pipe4xi_consumer_channel.recv())
    # ['DragonXi4_Reasoning_01', 'BIO ', 'Energy ']
    # ['DragonXi4_Reasoning_02', 'Geo ', 'Energy ']
    # ['DragonXi4_Reasoning_03', 'Hydrogen ', 'Energy ']
    # ['DragonXi4_Reasoning_04', 'Nuclear Power ', 'Energy ']
    # ['DragonXi4_Reasoning_05', 'Ocean ', 'Energy ']
    # ['DragonXi4_Reasoning_06', 'Solar ', 'Energy ']
    # ['DragonXi4_Reasoning_07', 'Wind ', 'Energy ']
    
    
    print("\n(STEP 5A/33) Dictionary created by manager4xi and updated by process4xi OF TEST_PROCESSREF_MP_XI4:")
    print (dict4xi)
    # {1: 'BIO', 2: 'Geo', 3: 'Hydrogen', 4: 'Nuclear Power', 5: 'Ocean', 6: 'Solar', 7: 'Wind'}
    print("\n(STEP 5BA/33) List for manager4xi and process4xi OF TEST_PROCESSREF_MP_XI4:")
    print (list4xi)
    # [0, 1, 2, 3, 4, 5, 6]
    process4xi.join()
    print ("(STEP 5C/33) process4xi exit code after join OF TEST_PROCESSREF_MP_XI4: ", process4xi.exitcode) # see how the process did exit
    # 0
    
    # ---------------------------------------------------------------------------------------------
    # ACE IT!
    #        create a process and use its services such the content it sends via its queue and pipe    
    # 
    print("\n(STEP 6A/33) ACE IT with yourDragonXi! OF TEST_PROCESSREF_MP_XI4 ", time4xi())
    
    process8xi = Process4Xi(target=ace, args=('Energy ',queue8xi, pipe8xi_publisher_channel,lock_xi8,dict8xi,list8xi))
    
    process8xi.start()
    
    process8xi.run()
           
    print ("(STEP 6B/33)process8xi alive status OF TEST_PROCESSREF_MP_XI4: ", process8xi.is_alive())       # check whether the process is alive
    # True 
    print ("(STEP 6C/33)process8xi name OF TEST_PROCESSREF_MP_XI4: ", process8xi.name)                     # the name of the process
    # Process4Xi-3
    print ("(STEP 6D/33)process8xi PID OF TEST_PROCESSREF_MP_XI4: ", process8xi.ident)                     # pid = ident of the process
    # 4544
    print ("(STEP 6E/33)process8xi authentication key: ", process8xi.authkey)    # authorization key given by the system
    # b"@`\x96\x849\x18\x831g\x81p\xb2\x06\x9a\xdc;\xa1\x85<\xba\x0b\xcc'u\xef\x83\xe84F&!\xb7"
    
    print (queue8xi.get())
    # ['DragonXi8_00', 'Energy ', 'to be aced!']
    
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    print (pipe8xi_consumer_channel.recv())
    # ['DragonXi8_Ace_01', 'BIO ', 'Energy ']
    # ['DragonXi8_Ace_02', 'Hydrogen ', 'Energy ']
    # ['DragonXi8_Ace_03', 'Nuclear Power ', 'Energy ']
    # ['DragonXi8_Ace_04', 'Solar ', 'Energy ']
    # ['DragonXi8_Ace_05', 'Wind ', 'Energy ']  
      
    print("\n(STEP 7A/33) Dictionary created by manager8xi and updated by process8xi OF TEST_PROCESSREF_MP_XI4:")
    print (dict8xi)
    # {1: 'BIO', 2: 'Hydrogen', 3: 'Nuclear Power', 4: 'Solar', 5: 'Wind'}
    
    print("\n(STEP 7B/33) List for manager8xi and process8xi OF TEST_PROCESSREF_MP_XI4:")
    print (list8xi)
    # [0, 1, 2, 3, 4]
    
    process8xi.join()
    print ("(STEP 7C/33)process8xi exit code after join OF TEST_PROCESSREF_MP_XI4: ", process8xi.exitcode) # see how the process did exit
    # 0
    
    # ---------------------------------------------------------------------------------------------
    # CREATE THREE POOLS WITH WORKER PROCESSES 
    # ---------------------------------------------------------------------------------------------     
    pool2xi = Pool4Xi(processes=2)
    print ("\n(STEP 8A/33) CREATED POOL2XI WITH 2 PROCESSES ", pool2xi) 
    # <pool4xi.Pool4Xi object at 0x0000000003B0A208>
    
    pool4xi = Pool4Xi(processes=4)
    print ("\n(STEP 8B/33) CREATED POOL4XI WITH 4 PROCESSES ", pool4xi)
    # <pool4xi.Pool4Xi object at 0x0000000003B0A588>
    
    pool8xi = Pool4Xi(processes=8)
    print ("\n(STEP 8C/33) CREATED POOL8XI WITH 8 PROCESSES ", pool2xi)
    # <pool4xi.Pool4Xi object at 0x0000000003B0A208>
    
    # ---------------------------------------------------------------------------------------------
    # SENSE POOL RESULTS  
    # ---------------------------------------------------------------------------------------------    
    result2xi = pool2xi.apply_async(expxi2, (20,))
    print ("\n(STEP 9A/33) GOT RESULT2XI FUNCTION: ",result2xi)    
    # <applyresult4xi.ApplyResult4Xi object at 0x0000000003D49048>
    
    r2xi = result2xi.get(timeout=1)
    print ("\n(STEP 9B/33) GOT R2XI: ",r2xi)  
    # None <-- TO-BE-SOLVED!
    
    
    # ---------------------------------------------------------------------------------------------
    # REASON POOL RESULTS  
    # ---------------------------------------------------------------------------------------------    
    result4xi = pool4xi.apply_async(expxi4, (40,))
    print ("\n(STEP 10A/33) GOT RESULT4XI FUNCTION: ",result4xi)    
    # <applyresult4xi.ApplyResult4Xi object at 0x0000000003D495C0>
    
    r4xi = result4xi.get(timeout=1)
    print ("\n(STEP 10B/33) GOT R4XI: ",r4xi)     
    # None <-- TO-BE-SOLVED!
    
    # ---------------------------------------------------------------------------------------------
    # ACE POOL RESULTS  
    # ---------------------------------------------------------------------------------------------    
    result8xi = pool8xi.apply_async(expxi8, (80,))
    print ("\n(STEP 11A/33) GOT RESULT8XI FUNCTION: ",result8xi)    
    # <applyresult4xi.ApplyResult4Xi object at 0x0000000003D492B0>
    
    r8xi = result8xi.get(timeout=1)
    print ("\n(STEP 11B/33) GOT R8XI: ",r8xi)     
    # None <-- TO-BE-SOLVED!
            
    print("\n===============================================================")     
#</function4xi>
     
            

  

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_processref_mp_xi4" usage = "
#   testing process references
#">
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def test_processref_mp_xi4():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1/5) OF TEST_PROCESSREF_MP_XI4 - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:
        # print("(Step 2/5) OF TEST_PROCESSREF_MP_XI4 - STARTING TESTS WITH STANDARD MULTIPROCESSING : ", time4xi())
        # phase1()
        # ~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~2~
        # process2xi alive status:  True
        # process2xi name:  Process-4
        # process2xi PID:  2684
        # process2xi authentication key:  b'\xe3i\xa8\xf94"\x91\xe285\xf7\xb7G\xd7\x0c\xec\x8e\xd3R\x07\xadc$\xf6\nqv\x071?"\xc7'
        # ['DragonXi2_00', 'Energy ', 'sensing!']
        # ['DragonXi2_Sensing_01', 'BIO ', 'Energy ']
        # ['DragonXi2_Sensing_02', 'CO2 ', 'Energy ']
        # ['DragonXi2_Sensing_03', 'Coal ', 'Energy ']
        # ['DragonXi2_Sensing_04', 'Diesel ', 'Energy ']
        # ['DragonXi2_Sensing_05', 'Electricity ', 'Energy ']
        # ['DragonXi2_Sensing_06', 'Fusion ', 'Energy ']
        # ['DragonXi2_Sensing_07', 'Gas ', 'Energy ']
        # ['DragonXi2_Sensing_08', 'Geo ', 'Energy ']
        # ['DragonXi2_Sensing_09', 'Hydrogen ', 'Energy ']
        # ['DragonXi2_Sensing_10', 'Lithium ', 'Energy ']
        # ['DragonXi2_Sensing_11', 'Nuclear Power ', 'Energy ']
        # ['DragonXi2_Sensing_12', 'Ocean ', 'Energy ']
        # ['DragonXi2_Sensing_13', 'Oil ', 'Energy ']
        # ['DragonXi2_Sensing_14', 'Solar ', 'Energy ']
        # ['DragonXi2_Sensing_15', 'Wind ', 'Energy ']
        # 
        #  Dictionary created by manager2xi and updated by process2xi:
        # {1: 'BIO', 2: 'CO2'}
        # 
        #  List for manager2xi and process2xi:
        # [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14]
        # process2xi exit code after join :  0
        # 
        # ~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~4~
        # process4xi alive status:  True
        # process4xi name:  Process-5
        # process4xi PID:  3124
        # process4xi authentication key:  b'\xe3i\xa8\xf94"\x91\xe285\xf7\xb7G\xd7\x0c\xec\x8e\xd3R\x07\xadc$\xf6\nqv\x071?"\xc7'
        # ['DragonXi4_00', 'Energy ', 'portfolio must be sustainable!']
        # ['DragonXi4_Reasoning_01', 'BIO ', 'Energy ']
        # ['DragonXi4_Reasoning_02', 'Geo ', 'Energy ']
        # ['DragonXi4_Reasoning_03', 'Hydrogen ', 'Energy ']
        # ['DragonXi4_Reasoning_04', 'Nuclear Power ', 'Energy ']
        # ['DragonXi4_Reasoning_05', 'Ocean ', 'Energy ']
        # ['DragonXi4_Reasoning_06', 'Solar ', 'Energy ']
        # ['DragonXi4_Reasoning_07', 'Wind ', 'Energy ']
        # 
        #  Dictionary created by manager4xi and updated by process4xi:
        # {1: 'BIO', 2: 'Geo'}
        # 
        #  List for manager4xi and process4xi:
        # [0, 1, 2, 3, 4, 5, 6]
        # process4xi exit code after join :  0
        # 
        # ~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~8~
        # process8xi alive status:  True
        # process8xi name:  Process-6
        # process8xi PID:  4856
        # process8xi authentication key:  b'\xe3i\xa8\xf94"\x91\xe285\xf7\xb7G\xd7\x0c\xec\x8e\xd3R\x07\xadc$\xf6\nqv\x071?"\xc7'
        # ['DragonXi8_00', 'Energy ', 'to be aced!']
        # ['DragonXi8_Ace_01', 'BIO ', 'Energy ']
        # ['DragonXi8_Ace_02', 'Hydrogen ', 'Energy ']
        # ['DragonXi8_Ace_03', 'Nuclear Power ', 'Energy ']
        # ['DragonXi8_Ace_04', 'Solar ', 'Energy ']
        # ['DragonXi8_Ace_05', 'Wind ', 'Energy ']
        # 
        #  Dictionary created by manager8xi and updated by process8xi:
        # {1: 'BIO', 2: 'Hydrogen'}
        # 
        #  List for manager8xi and process8xi:
        # [0, 1, 2, 3, 4]
        # process8xi exit code after join :  0
        # 
        # Result from pool2xi workers:  400
        # 
        # Result from pool4xi workers:  2560000
        # 
        # Result from pool8xi workers:  1677721600000000
        
        # print("(Step 3/5) OF TEST_PROCESSREF_MP_XI4 - COMPLETED TESTS WITH STANDARD MULTIPROCESSING: ", time4xi())
        
                                                                     
        print("(Step 4/5) OF TEST_PROCESSREF_MP_XI4 - STARTING TESTS WITH DRAGONIZED MULTIPROCESSING: ", time4xi())
        # 06:16:34 01/15/13 Pacific Standard Time
        
        phase2() 
        
        print("(Step 5/5) OF TEST_PROCESSREF_MP_XI4 - COMPLETED TESTS WITH DRAGONIZED MULTIPROCESSING: ", time4xi())
        # 06:16:53 01/15/13 Pacific Standard Time
            
    finally:        
            
                    
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)        
       
        
#</function4xi>        
    
 
# -------------------------------------------------------------------------------------------------
# main                              
#<function4xi function = "main" usage = "
#   main function to test process references
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main():
    print('=' *33)
    print("SENSING IT WITH YOURDRAGONXI!")  
    print('=' *33)
        
    test_processref_mp_xi4() 
    
    print('=' *33)
    print("SENSED IT WITH YOURDRAGONXI!")    
    print('=' *33) 
    
#</function4xi>
        
# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':

    main()
    
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#    
# None
#"
#>


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_processref_mp_xi4.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
